<?php

require_once('RefTable.inc');


/** ObjCache
 * This class implements the object cache.
 *
 * FIXME : no error management, no documentation ; 1,* references, inheritance and types not handled properly
 */
class	ObjCache
{
	var	$dbHost;
	var	$dbName;
	var	$dbUser;
	var	$dbPass;
	var	$dbTable;
	var	$refSingle;
	var	$refTables;
	var	$refFields;
	var	$objs;
	var	$newObjs;
	var	$stack;
	var	$inDestroy;

	function	ObjCache($h, $db, $u, $p)
	{
		$this->dbHost		= $h;
		$this->dbName		= $db;
		$this->dbUser		= $u;
		$this->dbPass		= $p;
		$this->refSingle	= array();
		$this->refTables	= array();
		$this->refFields	= array();
		$this->objs		= array();
		$this->newObjs		= array();
		$this->stack		= array();
		$this->inDestroy	= false;

		$this->db = pg_connect("host='$h' dbname='$db' user='$u' password='$p'");
		$this->query("BEGIN TRANSACTION");
	}

	function	addReference($st, $sf, $dt)
	{
		$this->refSingle["$st;$sf"] = $dt;
	}

	function	addRefTable($t)
	{
		if	(!(is_object($t) && is_a($t, "reftable")) || isset($this->refTables[$t->name]))
			return;

		$this->refTables[$t->name] = $t;
		foreach ($t->refs as $tn => $ld)
		{
			if	($ld["af"] == "")
				continue;
			$af = $ld["af"];

			foreach ($t->refs as $tn2 => $ld2)
			{
				if	($tn == $tn2)
					continue;
				if	(!is_array($this->refFields[$tn2]))
					$this->refFields[$tn2] = array();
				$this->refFields[$tn2][$af] = array($t->name, $tn);
			}
		}
	}

	function	query($q)
	{
		if (isset($_SESSION["cache"])) echo "QUERY: <b>$q</b><br/>";
		return pg_query($this->db, $q);
	}

	function	destroy()
	{
		$this->inDestroy = true;
		$oks = array_keys($this->objs);
		foreach	($oks as $oid)
		{
			$o = &$this->objs[$oid];
			$this->commitObject(&$o);
		}
		$this->query("COMMIT");
		pg_close($this->db);
	}

	function	newObject(&$obj)
	{
		if	(!is_object($obj))
			return;

		$cl = get_class($obj);
		$r = $this->query("SELECT nextval('${cl}_id_seq'::text)");
		$row = pg_fetch_array($r);
		$oid = $row[0];

		$obj->id = $oid;
		$this->objs["$cl;$oid"] = &$obj;
		$this->newObjs["$cl;$oid"] = true;

		if	(!is_array($this->refFields[$cl]))
			return;

		foreach ($this->refFields[$cl] as $fn => $fd)
			$obj->$fn = array();
	}

	function	&getObject($class, $id)
	{
		if	(is_int(array_search("$class;$id", $this->stack)) || isset($this->objs[$class.";".$id]))
			return	$this->objs[$class.";".$id];

		array_push($this->stack, "$class;$id");
		$q = "SELECT * FROM $class WHERE id = $id FOR UPDATE";
		$r = $this->query($q);
		$row = pg_fetch_assoc($r);
		if	(!is_array($row))
		{
			array_pop($this->stack);
			return	null;
		}

		$ss = "O:" . strlen($class) . ":\"$class\":" . count($row) . ":{";
		$refs = array();
		foreach ($row as $k => $v)
		{
			if	($k == "id")
				$id = $v;
			$ss .= "s:" . strlen($k) . ":\"$k\";";
			if	(!is_null($v))
			{
				if	(isset($this->refSingle["$class;$k"]))
					$refs[$k] = $v;
				$ss .= "s:" . strlen($v) . ":\"$v\";";
			}
			else
				$ss .= "N;";
		}
		$ss .= "}";
//		print "<i>$ss</i><br>";
		$this->objs[$class.";".$id] = &unserialize($ss);

		foreach ($refs as $k => $v)
			$this->objs[$class.";".$id]->$k = &$this->getObject(
				$this->refSingle["$class;$k"], $v
			);

		// $this->refFields[$tn2][$af] = array($t->name, $tn);
		if	(is_array($this->refFields[$class]))
		{
			foreach ($this->refFields[$class] as $fn => $fdet)
			{
				list($rt, $tn) = $fdet;
				$q = $this->refTables[$rt]->genQuery($class, $id, $tn);
				$qr = $this->query($q);
				$this->objs[$class.";".$id]->$fn = array();

				while	($r = pg_fetch_row($qr))
				{
					array_push(
						$this->objs[$class.";".$id]->$fn,
						$this->getObject($tn, $r[0])
					);
				}
			}
		}

		array_pop($this->stack);
		return	$this->objs[$class.";".$id];
	}

	function	commitObject(&$o)
	{
		if	(!is_object($o))
			continue;
		$tn = get_class($o);
		$oid = "$tn;" . $o->id;

		$oc = get_object_vars($o);
		if	($this->newObjs[$oid])
		{
			$t = array();
			$k = array();
			foreach ($oc as $n => $m)
			{
				if	(is_null($m))
					$m = "NULL";
				elseif	(is_array($this->refFields[$tn]) && is_array($this->refFields[$tn][$n]))
					continue;
				elseif	(isset($this->refSingle["$tn;$n"]))
					$m = $m->id;
				else
					$m = "'".preg_replace("/'/", "''", $m)."'";
				array_push($k, $n);
				array_push($t, $m);
			}
			$q = "INSERT INTO $tn (" . join(',', $k) . ") VALUES (";
			$q .= join(',', $t) . ")";
		}
		else
		{
			$q = "UPDATE $tn SET ";
			$t = array();
			foreach ($oc as $n => $m)
			{
				if	($n == "id")
					continue;
				if	(is_null($m))
					$m = "NULL";
				elseif	(is_array($this->refFields[$tn]) && is_array($this->refFields[$tn][$n]))
					continue;
				elseif	(isset($this->refSingle["$tn;$n"]))
					$m = $m->id;
				else
					$m = "'".preg_replace("/'/", "''", $m)."'";
				array_push($t, "$n = $m");
			}
			$q .= join(',', $t) . " WHERE id = " . $o->id;
		}
		$this->query($q);

		if	(is_array($this->refFields[$tn]))
		{
			foreach ($this->refFields[$tn] as $rf => $rfp)
			{
				$tb = &$this->refTables[$rfp[0]];
				$this->query($tb->genDelete($tn, $o->id));
				$arr = &$o->$rfp[1];
				$lkeys = array_keys($arr);
				foreach ($lkeys as $lk)
				{
					if	(!is_object($arr[$lk]))
						continue;
					$this->query($tb->genInsert($tn, $o->id, $arr[$lk]->id));
				}
			}
		}

		if	($this->newObjs[$oid])
			$this->newObjs[$oid] = false;
	}

	function	deleteObject(&$obj)
	{
		if	(!is_object($obj) || !isset($obj->id)
			|| is_null($this->objs[get_class($obj).";".$obj->id])
			)
			return;
		if	(!$this->newObjs[get_class($obj).";".$obj->id])
		{
			$q = "DELETE FROM " . get_class($obj) . " WHERE id = " . $obj->id;
			$this->query($q);
		}
		unset($this->objs[get_class($obj) . ";" . $obj->id]);
	}

	function	__sleep()
	{
		$this->destroy();
		return	array('dbHost', 'dbName', 'dbUser', 'dbPass',
				'refSingle', 'refTables', 'refFields');
	}

	function	__wakeup()
	{
		$this->db = pg_connect(
			"host='" . $this->dbHost . "' "
			. "dbname='" . $this->dbName . "' "
			. "user='" . $this->dbUser . "' "
			. "password='" . $this->dbPass . "'"
		);
		$this->query("BEGIN TRANSACTION");
		$this->objs = array();
		$this->newObjs = array();
		$this->stack = array();
		$this->inDestroy = false;
	}
}

?>
