<?php

/** ObjCache
 * This class implements the object cache.
 *
 * FIXME : no error management, no documentation ; references, inheritance and types not handled properly
 */
class	ObjCache
{
	var	$dbHost;
	var	$dbName;
	var	$dbUser;
	var	$dbPass;
	var	$dbTable;
	var	$objs;
	var	$newObjs;

	function	ObjCache($h, $db, $u, $p)
	{
		$this->dbHost	= $h;
		$this->dbName	= $db;
		$this->dbUser	= $u;
		$this->dbPass	= $p;
		$this->objs	= array();
		$this->newObjs	= array();

		$this->db = pg_connect("host='$h' dbname='$db' user='$u' password='$p'");
		$this->query("BEGIN TRANSACTION");
	}

	function	query($q)
	{
//		echo "QUERY: <b>$q</b><br/>";
		return @pg_query($this->db, $q);
	}

	function	destroy()
	{
		$oks = array_keys($this->objs);
		foreach	($oks as $oid)
		{
			$o = &$this->objs[$oid];
			if	(!is_object($o))
				continue;

			$oc = get_object_vars($o);
			if	($this->newObjs[$oid])
			{
				$q = "INSERT INTO " . get_class($o) . " (" . join(',', array_keys($oc)) . ") VALUES (";
				$t = array();
				foreach ($oc as $m)
				{
					if	(is_null($m))
						$m = "NULL";
					else
						$m = "'".preg_replace("/'/", "''", $m)."'";
					array_push($t, $m);
				}
				$q .= join(',', $t) . ")";
			}
			else
			{
				$q = "UPDATE " . get_class($o) . " SET ";
				$t = array();
				foreach ($oc as $n => $m)
				{
					if	($n == "id")
						continue;
					if	(is_null($m))
						$m = "NULL";
					else
						$m = "'".preg_replace("/'/", "''", $m)."'";
					array_push($t, "$n = $m");
				}
				$q .= join(',', $t) . " WHERE id = " . $o->id;
			}
			$this->query($q);
		}
		$this->query("COMMIT");
		pg_close($this->db);
	}

	function	newObject(&$obj)
	{
		if	(!is_object($obj))
			return;
		$cl = get_class($obj);

		$r = $this->query("SELECT nextval('${cl}_id_seq'::text)");
		$row = pg_fetch_array($r);
		$oid = $row[0];
		$obj->id = $oid;
		$this->objs[get_class($obj) . ";" . $oid] = &$obj;
		$this->newObjs[get_class($obj) . ";" . $oid] = true;
	}

	function	&getObject($class, $id)
	{
		$q = "SELECT * FROM $class WHERE id = $id FOR UPDATE";
		$r = $this->query($q);
		$row = pg_fetch_assoc($r);
		if	(!is_array($row))
			return	null;

		$ss = "O:" . strlen($class) . ":\"$class\":" . count($row) . ":{";
		foreach ($row as $k => $v)
		{
			if	($k == "id")
				$id = $v;
			$ss .= "s:" . strlen($k) . ":\"$k\";";
			if	(!is_null($v))
				$ss .= "s:" . strlen($v) . ":\"$v\";";
			else
				$ss .= "N;";
		}
		$ss .= "}";
//		print "<i>$ss</i><br>";

		return	($this->objs[$class.";".$id] = unserialize($ss));
	}

	function	deleteObject(&$obj)
	{
		if	(!is_object($obj) || !isset($obj->id)
			|| is_null($this->objs[get_class($obj).";".$obj->id])
			)
			return;
		if	(!$this->newObjs[get_class($obj).";".$obj->id])
		{
			$q = "DELETE FROM " . get_class($obj) . " WHERE id = " . $obj->id;
			$this->query($q);
		}
		unset($this->objs[get_class($obj) . ";" . $obj->id]);
	}

	function	__sleep()
	{
		$this->destroy();
		return	array('dbHost', 'dbName', 'dbUser', 'dbPass');
	}

	function	__wakeup()
	{
		$this->db = pg_connect(
			"host='" . $this->dbHost . "' "
			. "dbname='" . $this->dbName . "' "
			. "user='" . $this->dbUser . "' "
			. "password='" . $this->dbPass . "'"
		);
		$this->query("BEGIN TRANSACTION");
		$this->objs = array();
		$this->newObjs = array();
	}
}

?>
